class Mover {
  PFont f;
  String text;
  float sw;
  float x;
  float y;
  float snelh;
  color c;

  float teller;
  float teller2;
  float r;

  Mover(String text_, float y_, float snelh_, color c_, PFont f_) {
    text = text_;
    y = y_;
    snelh = snelh_;
    c = c_;
    f = f_;
  }

  void rechthoek() {
    sw = textWidth(text);
    teller = teller + snelh;  
    //1) X richting
    if ((teller >=0 ) && (teller < width/3)) translate(teller, 0);
    //2) y richting
    if ((teller >= height/1.6875) && (teller < height/0.7941)) translate(width/3, -(teller-height/1.6875));
    //3) x richting
    if ((teller >= width/1.41176) && (teller < width/0.96+sw)) translate(teller-width/2.666, -height/1.5); 
    //4) y richting
    if ((teller >= height/0.54+sw) && (teller < height/0.397+sw)) translate(width/1.5+sw, -height/0.397-sw+teller);

    //5)  Actie: beweging in x richting naar eindpunt x = 960.
    //   Beginpunt x is de x waarde in vorige translate(x,y); = 640+sw
    //   eindpunt y is beginpunt y in de eerste stap y = 0,
    //   Instellingen teller:
    //   1) Beginstand teller = vorige eindstand teller = 1360+sw       
    //          Aantal tellen = 320-sw    
    //   2) Eindstand teller = beginstand teller + aantal tellen = 1360+sw+320-sw = 1680
    //   Instellingen van translate(x,y)
    //   x = teller-(eindstand teller - eindpunt x) = teller - (1680-960) 
    //   x = teller- 720
    //   y = eindpunt y eerste stap = 0   
    if ((teller >width/0.70588+sw) && (teller < width/0.5714+sw)) translate(teller-width/1.3333, 0);

    //sw wordt bij de eindstand teller opgeteld zodat de text uit het beeld kan lopen
    if (teller >= width/0.5714+sw) teller = 0;
  }

  void lijn() {
    sw = textWidth(text);
    teller2 = teller2 + snelh;  
    // X richting
    if ((teller2 >=0 ) && (teller2 < width+sw)) translate(teller2, 0);
    if (teller2 >= width+sw) teller2 = 0;
  }

  void display() {
    textAlign(RIGHT);
    textFont(f); 
    fill(c);           
    text(text, x, y);
  }

  void display2() {
    textAlign(CENTER);
    textFont(f); 
    fill(c);           
    text(text, x, y);
  }

  void trillen() {  
    x += random(-1, 1);  
    y += random(-1, 1);
  }

  void draaien() {  
    translate(width/2, height/2);  
    //translate verplaatst het middelpunt van het canvas naar het (0,0) punt van het assenstelsel 
    r = r + 1; //ook mag r++ 
    rotate(radians(r));  
    if (r == 360) r = 0;
  }
}