//CirkelVorm is een class waarin de vormen rect en ellipse in een cirkel worden gerangschikt
//een extra methode en constructor tbv een niet roterende rechthoek toegevoegd
class CirkelVorm { 
  float x;
  float y;
  float b; 
  float l; 
  float diameter;
  float hoek;
  int rotatiemode;
  int aantal;
  color c;

  //Argumenten van de constructor: 
  //vormlengte, vormbreedte, cirkeldiameter, start draaihoek, rotatiemode, aantal vormen, kleur.
  CirkelVorm(float l_, float b_, float d_, float hoek_, int rmod_, int aantal_, color c_) {            
    b = b_;       
    l = l_; 
    diameter = d_;
    hoek = hoek_;
    rotatiemode = rmod_;
    aantal = aantal_;
    c = c_;
  }
//Constructor voor de niet roterende rechthoek
  CirkelVorm(float x_, float y_, float l_, float b_, color c_) {
    x = x_;
    y = y_;
    l = l_;
    b = b_;
    c = c_;
  }

  void rechthoek() {
  //  translate(width/2, height/2);
    for (int i = 0; i < 360; i+=360/aantal) {
      float x = width/2 +  sin(radians(i))* diameter;
      float y = height/2 + cos(radians(i))* diameter;
      pushMatrix();
      translate(x, y);
      if (rotatiemode == 1) rotate(radians(-i+frameCount+hoek));
      if (rotatiemode == 2) rotateX(radians(-i+frameCount+hoek));
      if (rotatiemode == 3) rotateY(radians(-i+frameCount+hoek));
      fill(c);
      rectMode(CENTER);
      rect(0, 0, l, b, 25);
      popMatrix();
    }
  }

  void ellips() {
  //  translate(width/2, height/2);
    for (int i = 0; i < 360; i+=360/aantal) {
      float x = width/2 + sin(radians(i))* diameter;
      float y = height/2 + cos(radians(i))* diameter;
      pushMatrix();
      translate(x, y);
      if (rotatiemode == 1) rotate(radians(-i+frameCount+hoek));
      if (rotatiemode == 2) rotateX(radians(-i+frameCount+hoek));
      if (rotatiemode == 3) rotateY(radians(-i+frameCount+hoek));
      fill(c);
      ellipse(0, 0, l, b);
      popMatrix();
    }
  }
  void rechthoekNietRoterend() {
    rectMode(CENTER);
    fill(c);
    rect(x, y, l, b);
  }
}