ManSub man;
BezierCubicSub bez1;
BezierCubicSub bez2;
BezierCubicSub bez3;

void setup() {
  size(800, 800);
  man = new ManSub(width/2, height/2, 40, 100, color(0, 220, 0));
  //Punten van de Bezierkromme: eerste ankerpunt, controle punten 1 en 2, tweede ankerpunt 
  bez1 = new BezierCubicSub(width/2, height/2, width/4*3, height/4, width/4*3, height/2, width/2, height/2, color(0, 0, 100, 100));
  bez2 = new BezierCubicSub(width/2, height/2, width/4, height/4, width/4, height/2, width/2, height/2, color(0, 100, 0, 100));

  bez3 = new BezierCubicSub(0,0, width/4, height/4, width/4, height/2, 0,0, color(0,0, 0, 100));
}

void draw() {
  background(189, 237, 240);  
  bez1.display();
  bez2.display();
  man.display();
  
  bez1.neerEnOp();
  bez2.opEnNeer();
//De y waarden van de ankerpunten van bez3 bewegen zich tussen 0 en height  
  pushMatrix();
  bez3.draaien();
  bez3.display();
  popMatrix();
}

void keyPressed() {
  if (key == 's') {
    noLoop();
  }
  if (key == 'r') {
    loop();
  }
}