BezierQuadrCub rood; 
BezierQuadrCub groen;
BezierQuadrCub blauw;
BezierQuadrCub geel;
BezierQuadrCub paars;

void setup() { 
  // size(960, 540); 
  fullScreen();
  //argumenten van de constructor 
  // ankerpunt 1    (xa1,ya1)        1 en 2
  // ankerpunt 2    (width/2, ya2)   3
  // ankerpunt 3    (xa3,height/2)   4

  // controlepunt 1  (xc1,0)         5
  // controlepunt 2  (0,yc2)         6
  // controlepunt 3  (xc3,height/2)  7

  rood = new BezierQuadrCub(width/6*1, 0, height/2, width/2, width/3, height/2, width/3, color(255, 0, 0, 200));  
  groen = new BezierQuadrCub(width/6*2, 0, height/2, width/3, width/2, height/2, width/3, color(0, 255, 0, 100));
  blauw = new BezierQuadrCub(width/6*3, 0, height/2, width/2, width/3, height/2, width/3, color(0, 0, 255, 100));
  geel = new BezierQuadrCub(width/6*4, 0, height/2, width/3, width/2, height/2, width/3, color(255, 255, 0, 100));
  paars = new BezierQuadrCub(width/6*5, 0, height/2, width/2, width/3, height/2, width/3, color(255, 0, 255, 100));
} 
void draw() { 
  background(39, 208, 240);
  rood.display();
  groen.display();
  blauw.display();
  geel.display();
  paars.display();

  rood.nulWidthxa1();
  rood.heightNulya1();
  rood.nulHeightya1();

  rood.heightNulya2();
  rood.nulWidthxa3();

  groen.nulWidthxa1();
  groen.heightNulya1();
  groen.nulHeightya1();

  groen.heightNulya2();
  groen.nulWidthxa3();

  blauw.nulWidthxa1();
  blauw.heightNulya1();
  blauw.nulHeightya1();

  blauw.heightNulya2();
  blauw.nulWidthxa3();

  geel.nulWidthxa1();
  geel.heightNulya1();
  geel.nulHeightya1();

  geel.heightNulya2();
  geel.nulWidthxa3();

  paars.nulWidthxa1();
  paars.heightNulya1();
  paars.nulHeightya1();

  paars.heightNulya2();
  paars.nulWidthxa3();
}
void keyPressed() { 
  if (key == 's') { 
    noLoop();
  } 
  if (key == 'r') { 
    loop();
  }
}