class BezierQuadrCub {                 
  float xa1; float ya1; float ya2; float xa3; float xc1; float yc2; float xc3; 
  color c;

  int nulWidthxa1 = 1;
  int nulHeightya1 = 1;
  int nulWidthxa3  = 1;
  int nulHeightya2 = 1;
  int heightNulya1 = 1;

  //argumenten van de constructor 
  // ankerpunt 1    (xa1,ya1) 
  // ankerpunt 2    (width/2, ya2)
  // ankerpunt 3    (xa3,height/2)

  // controlepunt 1  (xc1,0)
  // controlepunt 2  (0,yc2)
  // controlepunt 3  (xc3,height/2)

  BezierQuadrCub(float xa1_, float ya1_, float ya2_, float xa3_, float xc1_, float yc2_, float xc3_, color c_) { 
    xa1 = xa1_;  ya1 = ya1_;  ya2 = ya2_;  xa3 = xa3_;  xc1 = xc1_; yc2 = yc2_; xc3 = xc3_; 
    c = c_;
  }

  void display() { 
    fill(c); 
    beginShape();
    vertex(xa1, ya1);
    quadraticVertex(xc1, 0, width/2, ya2);
    bezierVertex(0, yc2, xc3, height/2, xa3, height/2);
    endShape(CLOSE);
  }

  //beweging van xa1=0 naar xa1=width en terug
  void nulWidthxa1() {  
    xa1 = xa1 + nulWidthxa1;  
    if ((xa1 > width) || (xa1 < 0)) {  
      nulWidthxa1 = nulWidthxa1 * -1;
    }
  }
  //beweging van ya1=height naar ya1=0 en terug
  void heightNulya1() {  
    ya1 = ya1 - heightNulya1;  
    if ((ya1 > height) || (ya1 < 0)) {  
      heightNulya1 = heightNulya1 * -1;
    }
  }
  //beweging van ya1=0 naar ya1=height en terug
  void nulHeightya1() {  
    ya1 = ya1 + nulHeightya1;  
    if ((ya1 > height) || (ya1 < 0)) {  
      nulHeightya1 = nulHeightya1 * -1;
    }
  }
  //beweging van xa3=0 naar xa3=width en terug
  void nulWidthxa3() {  
    xa3 = xa3 + nulWidthxa1;  
    if ((xa3 > width) || (xa3 < 0)) {  
      nulWidthxa3 = nulWidthxa3 * -1;
    }
  }
  //beweging van ya2=0 naar ya1=height en terug
  void nulHeightya2() {  
    ya2 = ya2 + nulHeightya1;  
    if ((ya2 > height) || (ya2 < 0)) {  
      nulHeightya2 = nulHeightya2 * -1;
    }
  }
   //beweging van ya2=height naar ya1=0 en terug
  void heightNulya2() {  
    ya2 = ya2 - nulHeightya1;  
    if ((ya2 > height) || (ya2 < 0)) {  
      nulHeightya2 = nulHeightya2 * -1;
    }
  }
}