Vormen[] vormen = new Vormen[100];

void setup() { 
  fullScreen(P3D);
  //let op: length = 100, de index loopt van 0 t/m 99
  for(int i = 0; i < vormen.length/2; i++) { 
  //De cellen 0 t/m 49 bevatten veelhoeken
    vormen[i] = new Veelhoek(random(0, width), random(0, height), 50, 8, color(random(255), random(255), random(255), 100));
  }  
  //De cellen 50 t/m 94 van de array bevatten sterren 
  for (int i = vormen.length/2; i < vormen.length-6; i++ ) { 
    vormen[i] = new Ster(random(0, width), random(0, height), random(10, 100), 30, 20, color(random(255), random(255), random(255), 100));
  }  
  //Het initieeren van de vormen in cellen 95 t/m 99
  vormen[vormen.length-1] = new Ster(0, 0, 300, 100, 20, color(255, 0, 0, 100));
  vormen[vormen.length-2] = new Veelhoek(0, 0, 500, 6, color(255, 255, 0, 100));
  vormen[vormen.length-3] = new Ster(0, 0, 300, 100, 20, color(0, 255, 0, 100));
  vormen[vormen.length-4] = new Ster(0, 0, 300, 100, 20, color(0, 255, 255, 100));
  vormen[vormen.length-5] = new Ster(0, 0, 300, 100, 20, color(0, 0, 255, 100));
  vormen[vormen.length-6] = new Ster(0, 0, 200, 500, 6, color(0, 0, 255, 100));
} 

void draw() {
  background(0);
  //de max waarde van i = 93 dus cel 94 t/m 99 wordt niet getekend
  for (int i = 0; i < vormen.length-6; i++ ) { 
    //Lijntjes vanuit het midden naar centrum van iedere vorm
    //stroke(255, 255, 0); 
    //line(vormen[i].x, vormen[i].y, width/2, height/2);
    vormen[i].display();
  }
  pushMatrix();
  //De vorm in cel 99 draait in het eerste kwadant
  vormen[vormen.length-1].draaien1();
  vormen[vormen.length-1].display();
  popMatrix(); 

  pushMatrix();
  //De vorm in cel 98 draait in het midden
  vormen[vormen.length-2].draaienM();
  vormen[vormen.length-2].display();
  popMatrix(); 

  pushMatrix();
  //De vorm in cel 97 draait in het tweede kwadrant
  vormen[vormen.length-3].draaien2();
  vormen[vormen.length-3].display();
  popMatrix(); 

  pushMatrix();
  //De vorm in cel 96 draait in het derde kwadrant
  vormen[vormen.length-4].draaien3();
  vormen[vormen.length-4].display();
  popMatrix(); 

  pushMatrix();
  //De vorm in cel 95 draait in het vierde kwadrant
  vormen[vormen.length-5].draaien4();
  vormen[vormen.length-5].display();
  popMatrix();
  pushMatrix();
  //De vorm in cel 94 draait in het centrum
  vormen[vormen.length-6].draaienMLi();
  vormen[vormen.length-6].display();
  popMatrix();
}