Sphere ster;
Sphere ster2;

Sphere[] planeet = new Sphere[200];

void setup() {
  fullScreen(P3D);
//  size(1500, 389, P3D);
  ster = new Sphere(width/2, height/2, 0, 100, color(255, 255, 0));
  ster2 = new Sphere(width/4, height/2, 40, 50, color(0, 255, 255));

  for (int i = 0; i < planeet.length; i++) {  
    //constructor x,y,z positie, diameter, kleur
    planeet[i] = new Sphere(random(0, width), random(0, height), random(-height/3, height/3), 40, 
      color(random(0, 255), random(0, 255), random(0, 255), random(200, 220)));
  }
}

void draw() {
  //Achtergrondskleur van de flevopink template is E6FBFF
  //De header afbeelding is 1500 pixel X 389 pixel
  background(0);  
  for (int i=0; i < planeet.length/2; i++) {
    pushMatrix();
    planeet[i].draaienX();   
    planeet[i].display();   
    popMatrix();   
    stroke(255, 255, 0);
    line (planeet[i].x, planeet[i].y, width/2, height/2);
  }

  for (int i = planeet.length/2; i < planeet.length; i++) {
    pushMatrix();
    planeet[i].draaienY();   
    planeet[i].display(); 
    popMatrix(); 

    stroke(0, 255, 255);
    line (planeet[i].x, planeet[i].y, width/4, height/2);
  }
  pushMatrix();
  ster.display();
  popMatrix();

  pushMatrix();
  ster2.display();
  popMatrix();
}

void keyPressed() { 
  if (key == 'o') { 
    setup();
  }
} 